---
title: SVGTextContentElement
slug: Web/API/SVGTextContentElement
tags:
  - API
  - NeedsExample
  - Reference
  - SVG
  - SVG DOM
---
<div>{{APIRef("SVG")}}</div>

<p>The <strong><code>SVGTextContentElement</code></strong> interface is implemented by elements that support rendering child text content. It is inherited by various text-related interfaces, such as {{domxref("SVGTextElement")}}, {{domxref("SVGTSpanElement")}}, {{domxref("SVGTRefElement")}}, {{domxref("SVGAltGlyphElement")}} and {{domxref("SVGTextPathElement")}}.</p>

<p>{{InheritanceDiagram(600, 120)}}</p>

<h2 id="Constants">Constants</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <td>Constant</td>
   <td>Value</td>
   <td>Description</td>
  </tr>
  <tr>
   <td>LENGTHADJUST_UNKNOWN</td>
   <td>0</td>
   <td>Some other value.</td>
  </tr>
  <tr>
   <td>LENGTHADJUST_SPACING</td>
   <td>1</td>
   <td>The <code>spacing</code> keyword.</td>
  </tr>
  <tr>
   <td>LENGTHADJUST_SPACINGANDGLYPHS</td>
   <td>2</td>
   <td>The <code>spacingAndGlyphs</code> keyword.</td>
  </tr>
 </tbody>
</table>

<h2 id="Properties">Properties</h2>

<p><em>This interface also inherits properties from its parent, {{domxref("SVGGraphicsElement")}}.</em></p>

<dl>
 <dt>{{domxref("SVGTextContentElement.textLength")}} {{ReadOnlyInline}}</dt>
 <dd>An {{domxref("SVGAnimatedLength")}} reflecting the {{SVGAttr("textLength")}} attribute of the given element.</dd>
 <dt>{{domxref("SVGTextContentElement.lengthAdjust")}} {{ReadOnlyInline}}</dt>
 <dd>An {{domxref("SVGAnimatedEnumeration")}} reflecting the {{SVGAttr("lengthAdjust")}} attribute of the given element. The numeric type values represent one of the constant values above.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface also inherits methods from its parent, {{domxref("SVGGraphicsElement")}}.</em></p>

<dl>
 <dt>{{domxref("SVGTextContentElement.getNumberOfChars()")}}</dt>
 <dd>Returns a long representing the total number of addressable characters available for rendering within the current element, regardless of whether they will be rendered.</dd>
 <dt>{{domxref("SVGTextContentElement.getComputedTextLength()")}}</dt>
 <dd>Returns a float representing the computed length for the text within the element.</dd>
 <dt>{{domxref("SVGTextContentElement.getSubStringLength()")}}</dt>
 <dd>Returns a float representing the computed length of the formatted text advance distance for a substring of text within the element. Note that this method only accounts for the widths of the glyphs in the substring and any extra spacing inserted by the CSS 'letter-spacing' and 'word-spacing' properties. Visual spacing adjustments made by the 'x' attribute is ignored.</dd>
 <dt>{{domxref("SVGTextContentElement.getStartPositionOfChar()")}}</dt>
 <dd>Returns a {{domxref("DOMPoint")}} representing the position of a typographic character after text layout has been performed.
 <p class="note"><strong>Note:</strong> In SVG 1.1 this method returned an {{domxref("SVGPoint")}}.</p>
 </dd>
 <dt>{{domxref("SVGTextContentElement.getEndPositionOfChar()")}}</dt>
 <dd>Returns a {{domxref("DOMPoint")}} representing the trailing position of a typographic character after text layout has been performed.
 <p class="note"><strong>Note:</strong> In SVG 1.1 this method returned an {{domxref("SVGPoint")}}.</p>
 </dd>
 <dt>{{domxref("SVGTextContentElement.getExtentOfChar()")}}</dt>
 <dd>Returns a {{domxref("DOMRect")}} representing the computed tight bounding box of the glyph cell that corresponds to a given typographic character.</dd>
 <dt>{{domxref("SVGTextContentElement.getRotationOfChar()")}}</dt>
 <dd>Returns a float representing the rotation of typographic character.</dd>
 <dt>{{domxref("SVGTextContentElement.getCharNumAtPosition()")}}</dt>
 <dd>Returns a long representing the character which caused a text glyph to be rendered at a given position in the coordinate system. Because the relationship between characters and glyphs is not one-to-one, only the first character of the relevant typographic character is returned</dd>
 <dt>{{domxref("SVGTextContentElement.selectSubString()")}} {{deprecated_inline}}</dt>
 <dd>Selects text within the element.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("SVG2", "text.html#InterfaceSVGTextContentElement", "SVGTextContentElement")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>Changed inheritance from {{domxref("SVGElement")}} to {{domxref("SVGGraphicsElement")}} and <code>getStartPositionOfChar()</code> and removed implementations of {{domxref("SVGTests")}}, {{domxref("SVGLangSpace")}}, {{domxref("SVGExternalResourcesRequired")}}, {{domxref("SVGStylable")}} interfaces and <code>getEndPositionOfChar()</code> to return a {{domxref("DOMPoint")}} instead of an {{domxref("SVGPoint")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "text.html#InterfaceSVGTextContentElement", "SVGTextContentElement")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.SVGTextContentElement")}}</p>
